function block = cfun_ram(block,flag)

  if flag == 4 then      // Init
    useFiles = block.ipar(1);
    if useFiles == 1 & length(fileinfo('ram.in')) ~= 0
      block.oz(1)= fscanfMat('ram.in');
    end
  
  elseif flag == 2 then  // Update
    data_in = block.inptr(1)(1);
    address = block.inptr(2)(1) + 1;
    r_w     = block.inptr(3)(1);
  
    memsize = length(block.oz(1));
    if ((address > memsize) | (address <= 0))
      error('memory index out of bounds'); 
    end

    if r_w == 1   // write
      block.oz(1)(address) = data_in;
    end
    
  elseif flag == 1 then  // Output 
    address = block.inptr(2)(1) + 1;
    r_w     = block.inptr(3)(1);

    memsize = length(block.oz(1));
    if ((address > memsize) | (address <= 0))
      error('memory index out of bounds'); 
    end

    if r_w == 0  // read
      block.outptr(1) = block.oz(1)(address);
    else
      block.outptr(1) = 0.0;      
    end
    
  elseif flag == 5 then  // Terminate 
    useFiles = block.ipar(1);
    if useFiles == 1
      fid = mopen('ram.out', 'w');
      mfprintf(fid, '%5d\n', block.oz(1));
      mclose(fid);
    end
  end
    
endfunction
