function inVec = checkIntervals(x, low, high, N)
// divides the interval [low, high] in N subintervals and checks, whether x is 
// in any of them
// returns a vector with 0 or one for each interval.

  step = (high - low)/N;
  lowI = low:step:(high-step);
  highI = (low+step):step:high;

  inVec = double((lowI < x) & (x <= highI))';
endfunction;